/* Generated by Frama-C */
#include "stddef.h"
#include "stdio.h"
#include "string.h"
char *__gen_e_acsl_literal_string;
extern  __attribute__((__FC_BUILTIN__)) int __e_acsl_sound_verdict;

/*@ requires valid_string_src: valid_read_string(src);
    requires room_string: \valid(dest + (0 .. strlen(src)));
    requires
      separation:
        \separated(dest + (0 .. strlen(src)), src + (0 .. strlen(src)));
    ensures equal_contents: strcmp(\old(dest), \old(src)) ≡ 0;
    ensures result_ptr: \result ≡ \old(dest);
    assigns *(dest + (0 .. strlen{Old}(src))), \result;
    assigns *(dest + (0 .. strlen{Old}(src)))
      \from *(src + (0 .. strlen{Old}(src)));
    assigns \result \from dest;
 */
char *__gen_e_acsl_strcpy(char * restrict dest, char const * restrict src);

/*@ requires valid_nstring_src: valid_read_nstring(src, n);
    requires room_nstring: \valid(dest + (0 .. n - 1));
    requires separation: \separated(dest + (0 .. n - 1), src + (0 .. n - 1));
    ensures result_ptr: \result ≡ \old(dest);
    ensures initialization: \initialized(\old(dest) + (0 .. \old(n) - 1));
    assigns *(dest + (0 .. n - 1)), \result;
    assigns *(dest + (0 .. n - 1)) \from *(src + (0 .. n - 1));
    assigns \result \from dest;
    
    behavior complete:
      assumes src_fits: strlen(src) < n;
      ensures equal_after_copy: strcmp(\old(dest), \old(src)) ≡ 0;
    
    behavior partial:
      assumes src_too_long: n ≤ strlen(src);
      ensures
        equal_prefix:
          memcmp{Post, Post}(\old(dest), \old(src), \old(n)) ≡ 0;
 */
char *__gen_e_acsl_strncpy(char * restrict dest, char const * restrict src,
                           size_t n);

/*@ requires valid_string_src: valid_read_string(src);
    requires valid_string_dest: valid_string(dest);
    requires room_string: \valid(dest + (0 .. strlen(dest) + strlen(src)));
    ensures
      sum_of_lengths: strlen(\old(dest)) ≡ \old(strlen(dest) + strlen(src));
    ensures
      initialization: dest:
        \initialized(\old(dest) + (0 .. \old(strlen(dest) + strlen(src))));
    ensures
      dest_null_terminated:
        *(\old(dest) + \old(strlen(dest) + strlen(src))) ≡ 0;
    ensures result_ptr: \result ≡ \old(dest);
    assigns *(dest +
              (strlen{Old}(dest) .. strlen{Old}(dest) + strlen{Old}(src))),
            \result;
    assigns
    *(dest + (strlen{Old}(dest) .. strlen{Old}(dest) + strlen{Old}(src)))
      \from *(src + (0 .. strlen{Old}(src)));
    assigns \result \from dest;
 */
char *__gen_e_acsl_strcat(char * restrict dest, char const * restrict src);

/*@ requires valid_nstring_src: valid_read_nstring(src, n);
    requires valid_string_dest: valid_string(dest);
    ensures result_ptr: \result ≡ \old(dest);
    assigns *(dest + (strlen{Old}(dest) .. strlen{Old}(dest) + n)), \result;
    assigns *(dest + (strlen{Old}(dest) .. strlen{Old}(dest) + n))
      \from *(src + (0 .. n));
    assigns \result \from dest;
    
    behavior complete:
      assumes
        valid_string_src_fits: valid_read_string(src) ∧ strlen(src) ≤ n;
      requires
        room_string: \valid((dest + strlen(dest)) + (0 .. strlen(src)));
      ensures
        sum_of_lengths:
          strlen(\old(dest)) ≡ \old(strlen(dest) + strlen(src));
      assigns *(dest +
                (strlen{Old}(dest) .. strlen{Old}(dest) + strlen{Old}(src))),
              \result;
      assigns
      *(dest + (strlen{Old}(dest) .. strlen{Old}(dest) + strlen{Old}(src)))
        \from *(src + (0 .. strlen{Old}(src)));
      assigns \result \from dest;
    
    behavior partial:
      assumes
        valid_string_src_too_large:
          ¬(valid_read_string(src) ∧ strlen(src) ≤ n);
      requires room_string: \valid((dest + strlen(dest)) + (0 .. n));
      ensures
        sum_of_bounded_lengths:
          strlen(\old(dest)) ≡ \old(strlen(dest)) + \old(n);
      assigns *(dest + (strlen{Old}(dest) .. strlen{Old}(dest) + n)),
              \result;
      assigns *(dest + (strlen{Old}(dest) .. strlen{Old}(dest) + n))
        \from *(src + (0 .. strlen{Old}(src)));
      assigns \result \from dest;
 */
char *__gen_e_acsl_strncat(char * restrict dest, char const * restrict src,
                           size_t n);

/*@ requires valid_nstring_src: valid_read_nstring(src, n);
    requires valid_string_dest: valid_string(dest);
    ensures result_ptr: \result ≡ \old(dest);
    assigns *(dest + (strlen{Old}(dest) .. strlen{Old}(dest) + n)), \result;
    assigns *(dest + (strlen{Old}(dest) .. strlen{Old}(dest) + n))
      \from *(src + (0 .. n));
    assigns \result \from dest;
    
    behavior complete:
      assumes
        valid_string_src_fits: valid_read_string(src) ∧ strlen(src) ≤ n;
      requires
        room_string: \valid((dest + strlen(dest)) + (0 .. strlen(src)));
      ensures
        sum_of_lengths:
          strlen(\old(dest)) ≡ \old(strlen(dest) + strlen(src));
      assigns *(dest +
                (strlen{Old}(dest) .. strlen{Old}(dest) + strlen{Old}(src))),
              \result;
      assigns
      *(dest + (strlen{Old}(dest) .. strlen{Old}(dest) + strlen{Old}(src)))
        \from *(src + (0 .. strlen{Old}(src)));
      assigns \result \from dest;
    
    behavior partial:
      assumes
        valid_string_src_too_large:
          ¬(valid_read_string(src) ∧ strlen(src) ≤ n);
      requires room_string: \valid((dest + strlen(dest)) + (0 .. n));
      ensures
        sum_of_bounded_lengths:
          strlen(\old(dest)) ≡ \old(strlen(dest)) + \old(n);
      assigns *(dest + (strlen{Old}(dest) .. strlen{Old}(dest) + n)),
              \result;
      assigns *(dest + (strlen{Old}(dest) .. strlen{Old}(dest) + n))
        \from *(src + (0 .. strlen{Old}(src)));
      assigns \result \from dest;
 */
char *__gen_e_acsl_strncat(char * restrict dest, char const * restrict src,
                           size_t n)
{
  char *__gen_e_acsl_at;
  unsigned long __gen_e_acsl_strcat_dest_size;
  unsigned long __gen_e_acsl_strcat_src_size;
  __e_acsl_contract_t *__gen_e_acsl_contract;
  char *__retres;
  __e_acsl_store_block((void *)(& dest),(size_t)8);
  __gen_e_acsl_contract = __e_acsl_contract_init((size_t)2);
  __gen_e_acsl_strcat_src_size = __e_acsl_builtin_strlen(src);
  if (n < __gen_e_acsl_strcat_src_size) __gen_e_acsl_strcat_src_size = n;
  __gen_e_acsl_strcat_dest_size = __e_acsl_builtin_strlen((char const *)dest);
  __gen_e_acsl_at = dest;
  __retres = strncat(dest,src,n);
  {
    __e_acsl_mpz_t __gen_e_acsl___gen_e_acsl_strcat_src_size;
    __e_acsl_mpz_t __gen_e_acsl___gen_e_acsl_strcat_dest_size;
    __e_acsl_mpz_t __gen_e_acsl_add;
    __e_acsl_mpz_t __gen_e_acsl_;
    __e_acsl_mpz_t __gen_e_acsl_add_2;
    __e_acsl_mpz_t __gen_e_acsl__2;
    int __gen_e_acsl_le;
    unsigned long __gen_e_acsl_size;
    __gmpz_init_set_ui(__gen_e_acsl___gen_e_acsl_strcat_src_size,
                       __gen_e_acsl_strcat_src_size);
    __gmpz_init_set_ui(__gen_e_acsl___gen_e_acsl_strcat_dest_size,
                       __gen_e_acsl_strcat_dest_size);
    __gmpz_init(__gen_e_acsl_add);
    __gmpz_add(__gen_e_acsl_add,
               (__e_acsl_mpz_struct const *)(__gen_e_acsl___gen_e_acsl_strcat_src_size),
               (__e_acsl_mpz_struct const *)(__gen_e_acsl___gen_e_acsl_strcat_dest_size));
    __gmpz_init_set_si(__gen_e_acsl_,1L);
    __gmpz_init(__gen_e_acsl_add_2);
    __gmpz_add(__gen_e_acsl_add_2,
               (__e_acsl_mpz_struct const *)(__gen_e_acsl_add),
               (__e_acsl_mpz_struct const *)(__gen_e_acsl_));
    __gmpz_init_set_ui(__gen_e_acsl__2,18446744073709551615UL);
    __gen_e_acsl_le = __gmpz_cmp((__e_acsl_mpz_struct const *)(__gen_e_acsl_add_2),
                                 (__e_acsl_mpz_struct const *)(__gen_e_acsl__2));
    __e_acsl_assert(__gen_e_acsl_le <= 0,1,"RTE","strncat",
                    "size_lesser_or_eq_than_SIZE_MAX:\n  (__gen_e_acsl_strcat_src_size + __gen_e_acsl_strcat_dest_size) + 1 <=\n  18446744073709551615",
                    "FRAMAC_SHARE/libc/string.h",438);
    __gen_e_acsl_size = __gmpz_get_ui((__e_acsl_mpz_struct const *)(__gen_e_acsl_add_2));
    __e_acsl_initialize((void *)dest,__gen_e_acsl_size);
    __gmpz_clear(__gen_e_acsl___gen_e_acsl_strcat_src_size);
    __gmpz_clear(__gen_e_acsl___gen_e_acsl_strcat_dest_size);
    __gmpz_clear(__gen_e_acsl_add);
    __gmpz_clear(__gen_e_acsl_);
    __gmpz_clear(__gen_e_acsl_add_2);
    __gmpz_clear(__gen_e_acsl__2);
  }
  __e_acsl_assert(__retres == __gen_e_acsl_at,1,"Postcondition","strncat",
                  "result_ptr: \\result == \\old(dest)",
                  "FRAMAC_SHARE/libc/string.h",443);
  __e_acsl_contract_clean(__gen_e_acsl_contract);
  __e_acsl_delete_block((void *)(& dest));
  return __retres;
}

/*@ requires valid_string_src: valid_read_string(src);
    requires valid_string_dest: valid_string(dest);
    requires room_string: \valid(dest + (0 .. strlen(dest) + strlen(src)));
    ensures
      sum_of_lengths: strlen(\old(dest)) ≡ \old(strlen(dest) + strlen(src));
    ensures
      initialization: dest:
        \initialized(\old(dest) + (0 .. \old(strlen(dest) + strlen(src))));
    ensures
      dest_null_terminated:
        *(\old(dest) + \old(strlen(dest) + strlen(src))) ≡ 0;
    ensures result_ptr: \result ≡ \old(dest);
    assigns *(dest +
              (strlen{Old}(dest) .. strlen{Old}(dest) + strlen{Old}(src))),
            \result;
    assigns
    *(dest + (strlen{Old}(dest) .. strlen{Old}(dest) + strlen{Old}(src)))
      \from *(src + (0 .. strlen{Old}(src)));
    assigns \result \from dest;
 */
char *__gen_e_acsl_strcat(char * restrict dest, char const * restrict src)
{
  char *__gen_e_acsl_at_2;
  unsigned long __gen_e_acsl_strcat_dest_size;
  unsigned long __gen_e_acsl_strcat_src_size;
  char *__retres;
  __e_acsl_store_block((void *)(& dest),(size_t)8);
  __gen_e_acsl_strcat_src_size = __e_acsl_builtin_strlen(src);
  __gen_e_acsl_strcat_dest_size = __e_acsl_builtin_strlen((char const *)dest);
  __gen_e_acsl_at_2 = dest;
  __gen_e_acsl_at = dest;
  __retres = strcat(dest,src);
  {
    __e_acsl_mpz_t __gen_e_acsl___gen_e_acsl_strcat_src_size;
    __e_acsl_mpz_t __gen_e_acsl___gen_e_acsl_strcat_dest_size;
    __e_acsl_mpz_t __gen_e_acsl_add;
    __e_acsl_mpz_t __gen_e_acsl_;
    __e_acsl_mpz_t __gen_e_acsl_add_2;
    __e_acsl_mpz_t __gen_e_acsl__2;
    int __gen_e_acsl_le;
    unsigned long __gen_e_acsl_size;
    __gmpz_init_set_ui(__gen_e_acsl___gen_e_acsl_strcat_src_size,
                       __gen_e_acsl_strcat_src_size);
    __gmpz_init_set_ui(__gen_e_acsl___gen_e_acsl_strcat_dest_size,
                       __gen_e_acsl_strcat_dest_size);
    __gmpz_init(__gen_e_acsl_add);
    __gmpz_add(__gen_e_acsl_add,
               (__e_acsl_mpz_struct const *)(__gen_e_acsl___gen_e_acsl_strcat_src_size),
               (__e_acsl_mpz_struct const *)(__gen_e_acsl___gen_e_acsl_strcat_dest_size));
    __gmpz_init_set_si(__gen_e_acsl_,1L);
    __gmpz_init(__gen_e_acsl_add_2);
    __gmpz_add(__gen_e_acsl_add_2,
               (__e_acsl_mpz_struct const *)(__gen_e_acsl_add),
               (__e_acsl_mpz_struct const *)(__gen_e_acsl_));
    __gmpz_init_set_ui(__gen_e_acsl__2,18446744073709551615UL);
    __gen_e_acsl_le = __gmpz_cmp((__e_acsl_mpz_struct const *)(__gen_e_acsl_add_2),
                                 (__e_acsl_mpz_struct const *)(__gen_e_acsl__2));
    __e_acsl_assert(__gen_e_acsl_le <= 0,1,"RTE","strcat",
                    "size_lesser_or_eq_than_SIZE_MAX:\n  (__gen_e_acsl_strcat_src_size + __gen_e_acsl_strcat_dest_size) + 1 <=\n  18446744073709551615",
                    "FRAMAC_SHARE/libc/string.h",423);
    __gen_e_acsl_size = __gmpz_get_ui((__e_acsl_mpz_struct const *)(__gen_e_acsl_add_2));
    __e_acsl_initialize((void *)dest,__gen_e_acsl_size);
    __gmpz_clear(__gen_e_acsl___gen_e_acsl_strcat_src_size);
    __gmpz_clear(__gen_e_acsl___gen_e_acsl_strcat_dest_size);
    __gmpz_clear(__gen_e_acsl_add);
    __gmpz_clear(__gen_e_acsl_);
    __gmpz_clear(__gen_e_acsl_add_2);
    __gmpz_clear(__gen_e_acsl__2);
  }
  __e_acsl_assert(__retres == __gen_e_acsl_at_2,1,"Postcondition","strcat",
                  "result_ptr: \\result == \\old(dest)",
                  "FRAMAC_SHARE/libc/string.h",434);
  __e_acsl_delete_block((void *)(& dest));
  return __retres;
}

/*@ requires valid_nstring_src: valid_read_nstring(src, n);
    requires room_nstring: \valid(dest + (0 .. n - 1));
    requires separation: \separated(dest + (0 .. n - 1), src + (0 .. n - 1));
    ensures result_ptr: \result ≡ \old(dest);
    ensures initialization: \initialized(\old(dest) + (0 .. \old(n) - 1));
    assigns *(dest + (0 .. n - 1)), \result;
    assigns *(dest + (0 .. n - 1)) \from *(src + (0 .. n - 1));
    assigns \result \from dest;
    
    behavior complete:
      assumes src_fits: strlen(src) < n;
      ensures equal_after_copy: strcmp(\old(dest), \old(src)) ≡ 0;
    
    behavior partial:
      assumes src_too_long: n ≤ strlen(src);
      ensures
        equal_prefix:
          memcmp{Post, Post}(\old(dest), \old(src), \old(n)) ≡ 0;
 */
char *__gen_e_acsl_strncpy(char * restrict dest, char const * restrict src,
                           size_t n)
{
  __e_acsl_mpz_t __gen_e_acsl_at_3;
  char *__gen_e_acsl_at_2;
  char *__gen_e_acsl_at;
  __e_acsl_contract_t *__gen_e_acsl_contract;
  char *__retres;
  {
    unsigned long __gen_e_acsl_size;
    __e_acsl_mpz_t __gen_e_acsl_n;
    __e_acsl_mpz_t __gen_e_acsl_;
    __e_acsl_mpz_t __gen_e_acsl_sub;
    __e_acsl_mpz_t __gen_e_acsl__2;
    __e_acsl_mpz_t __gen_e_acsl_sub_2;
    __e_acsl_mpz_t __gen_e_acsl_add;
    unsigned long __gen_e_acsl__3;
    unsigned long __gen_e_acsl_if;
    int __gen_e_acsl_valid;
    unsigned long __gen_e_acsl_size_2;
    unsigned long __gen_e_acsl__4;
    unsigned long __gen_e_acsl_if_2;
    int __gen_e_acsl_valid_read;
    unsigned long __gen_e_acsl_size_3;
    unsigned long __gen_e_acsl__5;
    unsigned long __gen_e_acsl_if_3;
    int __gen_e_acsl_valid_read_2;
    unsigned long __gen_e_acsl_size_4;
    unsigned long __gen_e_acsl__6;
    unsigned long __gen_e_acsl_if_4;
    unsigned long __gen_e_acsl_size_5;
    unsigned long __gen_e_acsl__7;
    unsigned long __gen_e_acsl_if_5;
    int __gen_e_acsl_separated;
    __e_acsl_store_block((void *)(& src),(size_t)8);
    __e_acsl_store_block((void *)(& dest),(size_t)8);
    __gen_e_acsl_contract = __e_acsl_contract_init((size_t)2);
    __gmpz_init_set_ui(__gen_e_acsl_n,n);
    __gmpz_init_set_si(__gen_e_acsl_,1L);
    __gmpz_init(__gen_e_acsl_sub);
    __gmpz_sub(__gen_e_acsl_sub,
               (__e_acsl_mpz_struct const *)(__gen_e_acsl_n),
               (__e_acsl_mpz_struct const *)(__gen_e_acsl_));
    __gmpz_init_set_si(__gen_e_acsl__2,0L);
    __gmpz_init(__gen_e_acsl_sub_2);
    __gmpz_sub(__gen_e_acsl_sub_2,
               (__e_acsl_mpz_struct const *)(__gen_e_acsl_sub),
               (__e_acsl_mpz_struct const *)(__gen_e_acsl__2));
    __gmpz_init(__gen_e_acsl_add);
    __gmpz_add(__gen_e_acsl_add,
               (__e_acsl_mpz_struct const *)(__gen_e_acsl_sub_2),
               (__e_acsl_mpz_struct const *)(__gen_e_acsl_));
    __gen_e_acsl__3 = __gmpz_get_ui((__e_acsl_mpz_struct const *)(__gen_e_acsl_add));
    __gen_e_acsl_size = 1UL * __gen_e_acsl__3;
    if (__gen_e_acsl_size <= 0UL) __gen_e_acsl_if = 0UL;
    else __gen_e_acsl_if = __gen_e_acsl_size;
    __gen_e_acsl_valid = __e_acsl_valid((void *)(dest + 1 * 0),
                                        __gen_e_acsl_if,(void *)dest,
                                        (void *)(& dest));
    __e_acsl_assert(__gen_e_acsl_valid,1,"Precondition","strncpy",
                    "room_nstring: \\valid(dest + (0 .. n - 1))",
                    "FRAMAC_SHARE/libc/string.h",380);
    __gen_e_acsl__4 = __gmpz_get_ui((__e_acsl_mpz_struct const *)(__gen_e_acsl_add));
    __gen_e_acsl_size_2 = 1UL * __gen_e_acsl__4;
    if (__gen_e_acsl_size_2 <= 0UL) __gen_e_acsl_if_2 = 0UL;
    else __gen_e_acsl_if_2 = __gen_e_acsl_size_2;
    __gen_e_acsl_valid_read = __e_acsl_valid_read((void *)(dest + 1 * 0),
                                                  __gen_e_acsl_if_2,
                                                  (void *)dest,
                                                  (void *)(& dest));
    __e_acsl_assert(__gen_e_acsl_valid_read,1,"RTE","strncpy",
                    "separated_guard: \\valid_read(dest + (0 .. n - 1))",
                    "FRAMAC_SHARE/libc/string.h",382);
    __gen_e_acsl__5 = __gmpz_get_ui((__e_acsl_mpz_struct const *)(__gen_e_acsl_add));
    __gen_e_acsl_size_3 = 1UL * __gen_e_acsl__5;
    if (__gen_e_acsl_size_3 <= 0UL) __gen_e_acsl_if_3 = 0UL;
    else __gen_e_acsl_if_3 = __gen_e_acsl_size_3;
    __gen_e_acsl_valid_read_2 = __e_acsl_valid_read((void *)(src + 1 * 0),
                                                    __gen_e_acsl_if_3,
                                                    (void *)src,
                                                    (void *)(& src));
    __e_acsl_assert(__gen_e_acsl_valid_read_2,1,"RTE","strncpy",
                    "separated_guard: \\valid_read(src + (0 .. n - 1))",
                    "FRAMAC_SHARE/libc/string.h",382);
    __gen_e_acsl__6 = __gmpz_get_ui((__e_acsl_mpz_struct const *)(__gen_e_acsl_add));
    __gen_e_acsl_size_4 = 1UL * __gen_e_acsl__6;
    if (__gen_e_acsl_size_4 <= 0UL) __gen_e_acsl_if_4 = 0UL;
    else __gen_e_acsl_if_4 = __gen_e_acsl_size_4;
    __gen_e_acsl__7 = __gmpz_get_ui((__e_acsl_mpz_struct const *)(__gen_e_acsl_add));
    __gen_e_acsl_size_5 = 1UL * __gen_e_acsl__7;
    if (__gen_e_acsl_size_5 <= 0UL) __gen_e_acsl_if_5 = 0UL;
    else __gen_e_acsl_if_5 = __gen_e_acsl_size_5;
    __gen_e_acsl_separated = __e_acsl_separated((size_t)2,dest + 1 * 0,
                                                __gen_e_acsl_if_4,
                                                src + 1 * 0,
                                                __gen_e_acsl_if_5);
    __e_acsl_assert(__gen_e_acsl_separated,1,"Precondition","strncpy",
                    "separation: \\separated(dest + (0 .. n - 1), src + (0 .. n - 1))",
                    "FRAMAC_SHARE/libc/string.h",382);
    __gmpz_clear(__gen_e_acsl_n);
    __gmpz_clear(__gen_e_acsl_);
    __gmpz_clear(__gen_e_acsl_sub);
    __gmpz_clear(__gen_e_acsl__2);
    __gmpz_clear(__gen_e_acsl_sub_2);
    __gmpz_clear(__gen_e_acsl_add);
  }
  {
    __e_acsl_mpz_t __gen_e_acsl_n_2;
    __gmpz_init_set_ui(__gen_e_acsl_n_2,n);
    __gmpz_init_set(__gen_e_acsl_at_3,
                    (__e_acsl_mpz_struct const *)(__gen_e_acsl_n_2));
    __gmpz_clear(__gen_e_acsl_n_2);
  }
  __gen_e_acsl_at_2 = dest;
  __gen_e_acsl_at = dest;
  __retres = strncpy(dest,src,n);
  __e_acsl_initialize((void *)dest,n);
  {
    unsigned long __gen_e_acsl_size_6;
    __e_acsl_mpz_t __gen_e_acsl__8;
    __e_acsl_mpz_t __gen_e_acsl_sub_3;
    __e_acsl_mpz_t __gen_e_acsl__9;
    __e_acsl_mpz_t __gen_e_acsl_sub_4;
    __e_acsl_mpz_t __gen_e_acsl_add_2;
    unsigned long __gen_e_acsl__10;
    unsigned long __gen_e_acsl_if_6;
    int __gen_e_acsl_initialized;
    __e_acsl_assert(__retres == __gen_e_acsl_at,1,"Postcondition","strncpy",
                    "result_ptr: \\result == \\old(dest)",
                    "FRAMAC_SHARE/libc/string.h",385);
    __gmpz_init_set_si(__gen_e_acsl__8,1L);
    __gmpz_init(__gen_e_acsl_sub_3);
    __gmpz_sub(__gen_e_acsl_sub_3,
               (__e_acsl_mpz_struct const *)(__gen_e_acsl_at_3),
               (__e_acsl_mpz_struct const *)(__gen_e_acsl__8));
    __gmpz_init_set_si(__gen_e_acsl__9,0L);
    __gmpz_init(__gen_e_acsl_sub_4);
    __gmpz_sub(__gen_e_acsl_sub_4,
               (__e_acsl_mpz_struct const *)(__gen_e_acsl_sub_3),
               (__e_acsl_mpz_struct const *)(__gen_e_acsl__9));
    __gmpz_init(__gen_e_acsl_add_2);
    __gmpz_add(__gen_e_acsl_add_2,
               (__e_acsl_mpz_struct const *)(__gen_e_acsl_sub_4),
               (__e_acsl_mpz_struct const *)(__gen_e_acsl__8));
    __gen_e_acsl__10 = __gmpz_get_ui((__e_acsl_mpz_struct const *)(__gen_e_acsl_add_2));
    __gen_e_acsl_size_6 = 1UL * __gen_e_acsl__10;
    if (__gen_e_acsl_size_6 <= 0UL) __gen_e_acsl_if_6 = 0UL;
    else __gen_e_acsl_if_6 = __gen_e_acsl_size_6;
    __gen_e_acsl_initialized = __e_acsl_initialized((void *)(__gen_e_acsl_at_2 + 
                                                             1 * 0),
                                                    __gen_e_acsl_if_6);
    __e_acsl_assert(__gen_e_acsl_initialized,1,"Postcondition","strncpy",
                    "initialization: \\initialized(\\old(dest) + (0 .. \\old(n) - 1))",
                    "FRAMAC_SHARE/libc/string.h",386);
    __e_acsl_contract_clean(__gen_e_acsl_contract);
    __e_acsl_delete_block((void *)(& src));
    __e_acsl_delete_block((void *)(& dest));
    __gmpz_clear(__gen_e_acsl__8);
    __gmpz_clear(__gen_e_acsl_sub_3);
    __gmpz_clear(__gen_e_acsl__9);
    __gmpz_clear(__gen_e_acsl_sub_4);
    __gmpz_clear(__gen_e_acsl_add_2);
    __gmpz_clear(__gen_e_acsl_at_3);
    return __retres;
  }
}

/*@ requires valid_string_src: valid_read_string(src);
    requires room_string: \valid(dest + (0 .. strlen(src)));
    requires
      separation:
        \separated(dest + (0 .. strlen(src)), src + (0 .. strlen(src)));
    ensures equal_contents: strcmp(\old(dest), \old(src)) ≡ 0;
    ensures result_ptr: \result ≡ \old(dest);
    assigns *(dest + (0 .. strlen{Old}(src))), \result;
    assigns *(dest + (0 .. strlen{Old}(src)))
      \from *(src + (0 .. strlen{Old}(src)));
    assigns \result \from dest;
 */
char *__gen_e_acsl_strcpy(char * restrict dest, char const * restrict src)
{
  char *__gen_e_acsl_at;
  unsigned long __gen_e_acsl_strcpy_src_size;
  char *__retres;
  __e_acsl_store_block((void *)(& src),(size_t)8);
  __e_acsl_store_block((void *)(& dest),(size_t)8);
  __gen_e_acsl_strcpy_src_size = __e_acsl_builtin_strlen(src);
  __gen_e_acsl_at = dest;
  __retres = strcpy(dest,src);
  {
    __e_acsl_mpz_t __gen_e_acsl___gen_e_acsl_strcpy_src_size;
    __e_acsl_mpz_t __gen_e_acsl_;
    __e_acsl_mpz_t __gen_e_acsl_add;
    __e_acsl_mpz_t __gen_e_acsl__2;
    int __gen_e_acsl_le;
    unsigned long __gen_e_acsl_size;
    __gmpz_init_set_ui(__gen_e_acsl___gen_e_acsl_strcpy_src_size,
                       __gen_e_acsl_strcpy_src_size);
    __gmpz_init_set_si(__gen_e_acsl_,1L);
    __gmpz_init(__gen_e_acsl_add);
    __gmpz_add(__gen_e_acsl_add,
               (__e_acsl_mpz_struct const *)(__gen_e_acsl___gen_e_acsl_strcpy_src_size),
               (__e_acsl_mpz_struct const *)(__gen_e_acsl_));
    __gmpz_init_set_ui(__gen_e_acsl__2,18446744073709551615UL);
    __gen_e_acsl_le = __gmpz_cmp((__e_acsl_mpz_struct const *)(__gen_e_acsl_add),
                                 (__e_acsl_mpz_struct const *)(__gen_e_acsl__2));
    __e_acsl_assert(__gen_e_acsl_le <= 0,1,"RTE","strcpy",
                    "size_lesser_or_eq_than_SIZE_MAX:\n  __gen_e_acsl_strcpy_src_size + 1 <= 18446744073709551615",
                    "FRAMAC_SHARE/libc/string.h",367);
    __gen_e_acsl_size = __gmpz_get_ui((__e_acsl_mpz_struct const *)(__gen_e_acsl_add));
    __e_acsl_initialize((void *)dest,__gen_e_acsl_size);
    __gmpz_clear(__gen_e_acsl___gen_e_acsl_strcpy_src_size);
    __gmpz_clear(__gen_e_acsl_);
    __gmpz_clear(__gen_e_acsl_add);
    __gmpz_clear(__gen_e_acsl__2);
  }
  __e_acsl_assert(__retres == __gen_e_acsl_at,1,"Postcondition","strcpy",
                  "result_ptr: \\result == \\old(dest)",
                  "FRAMAC_SHARE/libc/string.h",374);
  __e_acsl_delete_block((void *)(& src));
  __e_acsl_delete_block((void *)(& dest));
  return __retres;
}

void __e_acsl_globals_init(void)
{
  static char __e_acsl_already_run = 0;
  if (! __e_acsl_already_run) {
    __e_acsl_already_run = 1;
    __gen_e_acsl_literal_string = "a";
    __e_acsl_store_block((void *)__gen_e_acsl_literal_string,sizeof("a"));
    __e_acsl_full_init((void *)__gen_e_acsl_literal_string);
    __e_acsl_mark_readonly((void *)__gen_e_acsl_literal_string);
  }
  return;
}

int main(void)
{
  int __retres;
  __e_acsl_memory_init((int *)0,(char ***)0,(size_t)8);
  __e_acsl_globals_init();
  {
    char dest[4];
    __e_acsl_store_block((void *)(dest),(size_t)4);
    char src[2] = {(char)'b', (char)'\000'};
    __e_acsl_store_block((void *)(src),(size_t)2);
    __e_acsl_full_init((void *)(& src));
    {
      int __gen_e_acsl_size;
      int __gen_e_acsl_if;
      int __gen_e_acsl_initialized;
      __gen_e_acsl_size = 1 * ((3 - 0) + 1);
      if (__gen_e_acsl_size <= 0) __gen_e_acsl_if = 0;
      else __gen_e_acsl_if = __gen_e_acsl_size;
      __gen_e_acsl_initialized = __e_acsl_initialized((void *)(dest + 1 * 0),
                                                      (size_t)__gen_e_acsl_if);
      __e_acsl_assert(! __gen_e_acsl_initialized,1,"Assertion","main",
                      "!\\initialized(&dest[0 .. 3])","tests/libc/str.c",12);
    }
    /*@ assert ¬\initialized(&dest[0 .. 3]); */ ;
    {
      int __gen_e_acsl_size_2;
      int __gen_e_acsl_if_2;
      int __gen_e_acsl_initialized_2;
      __gen_e_acsl_size_2 = 1 * ((1 - 0) + 1);
      if (__gen_e_acsl_size_2 <= 0) __gen_e_acsl_if_2 = 0;
      else __gen_e_acsl_if_2 = __gen_e_acsl_size_2;
      __gen_e_acsl_initialized_2 = __e_acsl_initialized((void *)(src + 1 * 0),
                                                        (size_t)__gen_e_acsl_if_2);
      __e_acsl_assert(__gen_e_acsl_initialized_2,1,"Assertion","main",
                      "\\initialized(&src[0 .. 1])","tests/libc/str.c",13);
    }
    /*@ assert \initialized(&src[0 .. 1]); */ ;
    __gen_e_acsl_strcpy(dest,(char const *)(src));
    {
      int __gen_e_acsl_size_3;
      int __gen_e_acsl_if_3;
      int __gen_e_acsl_initialized_3;
      __gen_e_acsl_size_3 = 1 * ((1 - 0) + 1);
      if (__gen_e_acsl_size_3 <= 0) __gen_e_acsl_if_3 = 0;
      else __gen_e_acsl_if_3 = __gen_e_acsl_size_3;
      __gen_e_acsl_initialized_3 = __e_acsl_initialized((void *)(dest + 1 * 0),
                                                        (size_t)__gen_e_acsl_if_3);
      __e_acsl_assert(__gen_e_acsl_initialized_3,1,"Assertion","main",
                      "\\initialized(&dest[0 .. 1])","tests/libc/str.c",16);
    }
    /*@ assert \initialized(&dest[0 .. 1]); */ ;
    {
      int __gen_e_acsl_size_4;
      int __gen_e_acsl_if_4;
      int __gen_e_acsl_initialized_4;
      __gen_e_acsl_size_4 = 1 * ((3 - 2) + 1);
      if (__gen_e_acsl_size_4 <= 0) __gen_e_acsl_if_4 = 0;
      else __gen_e_acsl_if_4 = __gen_e_acsl_size_4;
      __gen_e_acsl_initialized_4 = __e_acsl_initialized((void *)(dest + 1 * 2),
                                                        (size_t)__gen_e_acsl_if_4);
      __e_acsl_assert(! __gen_e_acsl_initialized_4,1,"Assertion","main",
                      "!\\initialized(&dest[2 .. 3])","tests/libc/str.c",17);
    }
    /*@ assert ¬\initialized(&dest[2 .. 3]); */ ;
    __e_acsl_delete_block((void *)(src));
    __e_acsl_delete_block((void *)(dest));
  }
  {
    char dest_0[4];
    __e_acsl_store_block((void *)(dest_0),(size_t)4);
    char src_0[4] = {(char)'a', (char)'b', (char)'\000'};
    __e_acsl_store_block((void *)(src_0),(size_t)4);
    __e_acsl_full_init((void *)(& src_0));
    {
      int __gen_e_acsl_size_5;
      int __gen_e_acsl_if_5;
      int __gen_e_acsl_initialized_5;
      __gen_e_acsl_size_5 = 1 * ((3 - 0) + 1);
      if (__gen_e_acsl_size_5 <= 0) __gen_e_acsl_if_5 = 0;
      else __gen_e_acsl_if_5 = __gen_e_acsl_size_5;
      __gen_e_acsl_initialized_5 = __e_acsl_initialized((void *)(dest_0 + 
                                                                 1 * 0),
                                                        (size_t)__gen_e_acsl_if_5);
      __e_acsl_assert(! __gen_e_acsl_initialized_5,1,"Assertion","main",
                      "!\\initialized(&dest_0[0 .. 3])","tests/libc/str.c",
                      22);
    }
    /*@ assert ¬\initialized(&dest_0[0 .. 3]); */ ;
    {
      int __gen_e_acsl_size_6;
      int __gen_e_acsl_if_6;
      int __gen_e_acsl_initialized_6;
      __gen_e_acsl_size_6 = 1 * ((3 - 0) + 1);
      if (__gen_e_acsl_size_6 <= 0) __gen_e_acsl_if_6 = 0;
      else __gen_e_acsl_if_6 = __gen_e_acsl_size_6;
      __gen_e_acsl_initialized_6 = __e_acsl_initialized((void *)(src_0 + 
                                                                 1 * 0),
                                                        (size_t)__gen_e_acsl_if_6);
      __e_acsl_assert(__gen_e_acsl_initialized_6,1,"Assertion","main",
                      "\\initialized(&src_0[0 .. 3])","tests/libc/str.c",23);
    }
    /*@ assert \initialized(&src_0[0 .. 3]); */ ;
    __gen_e_acsl_strncpy(dest_0,(char const *)(src_0),(unsigned long)1);
    {
      int __gen_e_acsl_initialized_7;
      __gen_e_acsl_initialized_7 = __e_acsl_initialized((void *)(dest_0),
                                                        sizeof(char));
      __e_acsl_assert(__gen_e_acsl_initialized_7,1,"Assertion","main",
                      "\\initialized((char *)dest_0)","tests/libc/str.c",26);
    }
    /*@ assert \initialized((char *)dest_0); */ ;
    {
      int __gen_e_acsl_size_7;
      int __gen_e_acsl_if_7;
      int __gen_e_acsl_initialized_8;
      __gen_e_acsl_size_7 = 1 * ((3 - 1) + 1);
      if (__gen_e_acsl_size_7 <= 0) __gen_e_acsl_if_7 = 0;
      else __gen_e_acsl_if_7 = __gen_e_acsl_size_7;
      __gen_e_acsl_initialized_8 = __e_acsl_initialized((void *)(dest_0 + 
                                                                 1 * 1),
                                                        (size_t)__gen_e_acsl_if_7);
      __e_acsl_assert(! __gen_e_acsl_initialized_8,1,"Assertion","main",
                      "!\\initialized(&dest_0[1 .. 3])","tests/libc/str.c",
                      27);
    }
    /*@ assert ¬\initialized(&dest_0[1 .. 3]); */ ;
    __e_acsl_delete_block((void *)(src_0));
    __e_acsl_delete_block((void *)(dest_0));
  }
  {
    char dest_1[4];
    __e_acsl_store_block((void *)(dest_1),(size_t)4);
    char src_1[4] = {(char)'b', (char)'\000'};
    __e_acsl_store_block((void *)(src_1),(size_t)4);
    __e_acsl_full_init((void *)(& src_1));
    {
      int __gen_e_acsl_size_8;
      int __gen_e_acsl_if_8;
      int __gen_e_acsl_initialized_9;
      __gen_e_acsl_size_8 = 1 * ((3 - 0) + 1);
      if (__gen_e_acsl_size_8 <= 0) __gen_e_acsl_if_8 = 0;
      else __gen_e_acsl_if_8 = __gen_e_acsl_size_8;
      __gen_e_acsl_initialized_9 = __e_acsl_initialized((void *)(dest_1 + 
                                                                 1 * 0),
                                                        (size_t)__gen_e_acsl_if_8);
      __e_acsl_assert(! __gen_e_acsl_initialized_9,1,"Assertion","main",
                      "!\\initialized(&dest_1[0 .. 3])","tests/libc/str.c",
                      32);
    }
    /*@ assert ¬\initialized(&dest_1[0 .. 3]); */ ;
    {
      int __gen_e_acsl_size_9;
      int __gen_e_acsl_if_9;
      int __gen_e_acsl_initialized_10;
      __gen_e_acsl_size_9 = 1 * ((3 - 0) + 1);
      if (__gen_e_acsl_size_9 <= 0) __gen_e_acsl_if_9 = 0;
      else __gen_e_acsl_if_9 = __gen_e_acsl_size_9;
      __gen_e_acsl_initialized_10 = __e_acsl_initialized((void *)(src_1 + 
                                                                  1 * 0),
                                                         (size_t)__gen_e_acsl_if_9);
      __e_acsl_assert(__gen_e_acsl_initialized_10,1,"Assertion","main",
                      "\\initialized(&src_1[0 .. 3])","tests/libc/str.c",33);
    }
    /*@ assert \initialized(&src_1[0 .. 3]); */ ;
    __gen_e_acsl_strncpy(dest_1,(char const *)(src_1),(unsigned long)3);
    {
      int __gen_e_acsl_size_10;
      int __gen_e_acsl_if_10;
      int __gen_e_acsl_initialized_11;
      __gen_e_acsl_size_10 = 1 * ((2 - 0) + 1);
      if (__gen_e_acsl_size_10 <= 0) __gen_e_acsl_if_10 = 0;
      else __gen_e_acsl_if_10 = __gen_e_acsl_size_10;
      __gen_e_acsl_initialized_11 = __e_acsl_initialized((void *)(dest_1 + 
                                                                  1 * 0),
                                                         (size_t)__gen_e_acsl_if_10);
      __e_acsl_assert(__gen_e_acsl_initialized_11,1,"Assertion","main",
                      "\\initialized(&dest_1[0 .. 2])","tests/libc/str.c",36);
    }
    /*@ assert \initialized(&dest_1[0 .. 2]); */ ;
    {
      int __gen_e_acsl_initialized_12;
      __gen_e_acsl_initialized_12 = __e_acsl_initialized((void *)(& dest_1[3]),
                                                         sizeof(char));
      __e_acsl_assert(! __gen_e_acsl_initialized_12,1,"Assertion","main",
                      "!\\initialized(&dest_1[3])","tests/libc/str.c",37);
    }
    /*@ assert ¬\initialized(&dest_1[3]); */ ;
    __e_acsl_delete_block((void *)(src_1));
    __e_acsl_delete_block((void *)(dest_1));
  }
  {
    char dest_2[4];
    __e_acsl_store_block((void *)(dest_2),(size_t)4);
    __gen_e_acsl_strcpy(dest_2,__gen_e_acsl_literal_string);
    char src_2[2] = {(char)'b', (char)'\000'};
    __e_acsl_store_block((void *)(src_2),(size_t)2);
    __e_acsl_full_init((void *)(& src_2));
    {
      int __gen_e_acsl_size_11;
      int __gen_e_acsl_if_11;
      int __gen_e_acsl_initialized_13;
      __gen_e_acsl_size_11 = 1 * ((1 - 0) + 1);
      if (__gen_e_acsl_size_11 <= 0) __gen_e_acsl_if_11 = 0;
      else __gen_e_acsl_if_11 = __gen_e_acsl_size_11;
      __gen_e_acsl_initialized_13 = __e_acsl_initialized((void *)(dest_2 + 
                                                                  1 * 0),
                                                         (size_t)__gen_e_acsl_if_11);
      __e_acsl_assert(__gen_e_acsl_initialized_13,1,"Assertion","main",
                      "\\initialized(&dest_2[0 .. 1])","tests/libc/str.c",43);
    }
    /*@ assert \initialized(&dest_2[0 .. 1]); */ ;
    {
      int __gen_e_acsl_size_12;
      int __gen_e_acsl_if_12;
      int __gen_e_acsl_initialized_14;
      __gen_e_acsl_size_12 = 1 * ((3 - 2) + 1);
      if (__gen_e_acsl_size_12 <= 0) __gen_e_acsl_if_12 = 0;
      else __gen_e_acsl_if_12 = __gen_e_acsl_size_12;
      __gen_e_acsl_initialized_14 = __e_acsl_initialized((void *)(dest_2 + 
                                                                  1 * 2),
                                                         (size_t)__gen_e_acsl_if_12);
      __e_acsl_assert(! __gen_e_acsl_initialized_14,1,"Assertion","main",
                      "!\\initialized(&dest_2[2 .. 3])","tests/libc/str.c",
                      44);
    }
    /*@ assert ¬\initialized(&dest_2[2 .. 3]); */ ;
    {
      int __gen_e_acsl_size_13;
      int __gen_e_acsl_if_13;
      int __gen_e_acsl_initialized_15;
      __gen_e_acsl_size_13 = 1 * ((1 - 0) + 1);
      if (__gen_e_acsl_size_13 <= 0) __gen_e_acsl_if_13 = 0;
      else __gen_e_acsl_if_13 = __gen_e_acsl_size_13;
      __gen_e_acsl_initialized_15 = __e_acsl_initialized((void *)(src_2 + 
                                                                  1 * 0),
                                                         (size_t)__gen_e_acsl_if_13);
      __e_acsl_assert(__gen_e_acsl_initialized_15,1,"Assertion","main",
                      "\\initialized(&src_2[0 .. 1])","tests/libc/str.c",45);
    }
    /*@ assert \initialized(&src_2[0 .. 1]); */ ;
    __gen_e_acsl_strcat(dest_2,(char const *)(src_2));
    {
      int __gen_e_acsl_size_14;
      int __gen_e_acsl_if_14;
      int __gen_e_acsl_initialized_16;
      __gen_e_acsl_size_14 = 1 * ((2 - 0) + 1);
      if (__gen_e_acsl_size_14 <= 0) __gen_e_acsl_if_14 = 0;
      else __gen_e_acsl_if_14 = __gen_e_acsl_size_14;
      __gen_e_acsl_initialized_16 = __e_acsl_initialized((void *)(dest_2 + 
                                                                  1 * 0),
                                                         (size_t)__gen_e_acsl_if_14);
      __e_acsl_assert(__gen_e_acsl_initialized_16,1,"Assertion","main",
                      "\\initialized(&dest_2[0 .. 2])","tests/libc/str.c",48);
    }
    /*@ assert \initialized(&dest_2[0 .. 2]); */ ;
    {
      int __gen_e_acsl_initialized_17;
      __gen_e_acsl_initialized_17 = __e_acsl_initialized((void *)(& dest_2[3]),
                                                         sizeof(char));
      __e_acsl_assert(! __gen_e_acsl_initialized_17,1,"Assertion","main",
                      "!\\initialized(&dest_2[3])","tests/libc/str.c",49);
    }
    /*@ assert ¬\initialized(&dest_2[3]); */ ;
    __e_acsl_delete_block((void *)(src_2));
    __e_acsl_delete_block((void *)(dest_2));
  }
  {
    char dest_3[4];
    __e_acsl_store_block((void *)(dest_3),(size_t)4);
    __gen_e_acsl_strcpy(dest_3,__gen_e_acsl_literal_string);
    char src_3[3] = {(char)'b', (char)'c', (char)'\000'};
    __e_acsl_store_block((void *)(src_3),(size_t)3);
    __e_acsl_full_init((void *)(& src_3));
    {
      int __gen_e_acsl_size_15;
      int __gen_e_acsl_if_15;
      int __gen_e_acsl_initialized_18;
      __gen_e_acsl_size_15 = 1 * ((1 - 0) + 1);
      if (__gen_e_acsl_size_15 <= 0) __gen_e_acsl_if_15 = 0;
      else __gen_e_acsl_if_15 = __gen_e_acsl_size_15;
      __gen_e_acsl_initialized_18 = __e_acsl_initialized((void *)(dest_3 + 
                                                                  1 * 0),
                                                         (size_t)__gen_e_acsl_if_15);
      __e_acsl_assert(__gen_e_acsl_initialized_18,1,"Assertion","main",
                      "\\initialized(&dest_3[0 .. 1])","tests/libc/str.c",55);
    }
    /*@ assert \initialized(&dest_3[0 .. 1]); */ ;
    {
      int __gen_e_acsl_size_16;
      int __gen_e_acsl_if_16;
      int __gen_e_acsl_initialized_19;
      __gen_e_acsl_size_16 = 1 * ((3 - 2) + 1);
      if (__gen_e_acsl_size_16 <= 0) __gen_e_acsl_if_16 = 0;
      else __gen_e_acsl_if_16 = __gen_e_acsl_size_16;
      __gen_e_acsl_initialized_19 = __e_acsl_initialized((void *)(dest_3 + 
                                                                  1 * 2),
                                                         (size_t)__gen_e_acsl_if_16);
      __e_acsl_assert(! __gen_e_acsl_initialized_19,1,"Assertion","main",
                      "!\\initialized(&dest_3[2 .. 3])","tests/libc/str.c",
                      56);
    }
    /*@ assert ¬\initialized(&dest_3[2 .. 3]); */ ;
    {
      int __gen_e_acsl_size_17;
      int __gen_e_acsl_if_17;
      int __gen_e_acsl_initialized_20;
      __gen_e_acsl_size_17 = 1 * ((2 - 0) + 1);
      if (__gen_e_acsl_size_17 <= 0) __gen_e_acsl_if_17 = 0;
      else __gen_e_acsl_if_17 = __gen_e_acsl_size_17;
      __gen_e_acsl_initialized_20 = __e_acsl_initialized((void *)(src_3 + 
                                                                  1 * 0),
                                                         (size_t)__gen_e_acsl_if_17);
      __e_acsl_assert(__gen_e_acsl_initialized_20,1,"Assertion","main",
                      "\\initialized(&src_3[0 .. 2])","tests/libc/str.c",57);
    }
    /*@ assert \initialized(&src_3[0 .. 2]); */ ;
    __gen_e_acsl_strncat(dest_3,(char const *)(src_3),(unsigned long)1);
    {
      int __gen_e_acsl_size_18;
      int __gen_e_acsl_if_18;
      int __gen_e_acsl_initialized_21;
      __gen_e_acsl_size_18 = 1 * ((2 - 0) + 1);
      if (__gen_e_acsl_size_18 <= 0) __gen_e_acsl_if_18 = 0;
      else __gen_e_acsl_if_18 = __gen_e_acsl_size_18;
      __gen_e_acsl_initialized_21 = __e_acsl_initialized((void *)(dest_3 + 
                                                                  1 * 0),
                                                         (size_t)__gen_e_acsl_if_18);
      __e_acsl_assert(__gen_e_acsl_initialized_21,1,"Assertion","main",
                      "\\initialized(&dest_3[0 .. 2])","tests/libc/str.c",60);
    }
    /*@ assert \initialized(&dest_3[0 .. 2]); */ ;
    {
      int __gen_e_acsl_initialized_22;
      __gen_e_acsl_initialized_22 = __e_acsl_initialized((void *)(& dest_3[3]),
                                                         sizeof(char));
      __e_acsl_assert(! __gen_e_acsl_initialized_22,1,"Assertion","main",
                      "!\\initialized(&dest_3[3])","tests/libc/str.c",61);
    }
    /*@ assert ¬\initialized(&dest_3[3]); */ ;
    __e_acsl_delete_block((void *)(src_3));
    __e_acsl_delete_block((void *)(dest_3));
  }
  {
    char dest_4[4];
    __e_acsl_store_block((void *)(dest_4),(size_t)4);
    __gen_e_acsl_strcpy(dest_4,__gen_e_acsl_literal_string);
    char src_4[2] = {(char)'b', (char)'\000'};
    __e_acsl_store_block((void *)(src_4),(size_t)2);
    __e_acsl_full_init((void *)(& src_4));
    {
      int __gen_e_acsl_size_19;
      int __gen_e_acsl_if_19;
      int __gen_e_acsl_initialized_23;
      __gen_e_acsl_size_19 = 1 * ((1 - 0) + 1);
      if (__gen_e_acsl_size_19 <= 0) __gen_e_acsl_if_19 = 0;
      else __gen_e_acsl_if_19 = __gen_e_acsl_size_19;
      __gen_e_acsl_initialized_23 = __e_acsl_initialized((void *)(dest_4 + 
                                                                  1 * 0),
                                                         (size_t)__gen_e_acsl_if_19);
      __e_acsl_assert(__gen_e_acsl_initialized_23,1,"Assertion","main",
                      "\\initialized(&dest_4[0 .. 1])","tests/libc/str.c",67);
    }
    /*@ assert \initialized(&dest_4[0 .. 1]); */ ;
    {
      int __gen_e_acsl_size_20;
      int __gen_e_acsl_if_20;
      int __gen_e_acsl_initialized_24;
      __gen_e_acsl_size_20 = 1 * ((3 - 2) + 1);
      if (__gen_e_acsl_size_20 <= 0) __gen_e_acsl_if_20 = 0;
      else __gen_e_acsl_if_20 = __gen_e_acsl_size_20;
      __gen_e_acsl_initialized_24 = __e_acsl_initialized((void *)(dest_4 + 
                                                                  1 * 2),
                                                         (size_t)__gen_e_acsl_if_20);
      __e_acsl_assert(! __gen_e_acsl_initialized_24,1,"Assertion","main",
                      "!\\initialized(&dest_4[2 .. 3])","tests/libc/str.c",
                      68);
    }
    /*@ assert ¬\initialized(&dest_4[2 .. 3]); */ ;
    {
      int __gen_e_acsl_size_21;
      int __gen_e_acsl_if_21;
      int __gen_e_acsl_initialized_25;
      __gen_e_acsl_size_21 = 1 * ((1 - 0) + 1);
      if (__gen_e_acsl_size_21 <= 0) __gen_e_acsl_if_21 = 0;
      else __gen_e_acsl_if_21 = __gen_e_acsl_size_21;
      __gen_e_acsl_initialized_25 = __e_acsl_initialized((void *)(src_4 + 
                                                                  1 * 0),
                                                         (size_t)__gen_e_acsl_if_21);
      __e_acsl_assert(__gen_e_acsl_initialized_25,1,"Assertion","main",
                      "\\initialized(&src_4[0 .. 1])","tests/libc/str.c",69);
    }
    /*@ assert \initialized(&src_4[0 .. 1]); */ ;
    __gen_e_acsl_strncat(dest_4,(char const *)(src_4),(unsigned long)2);
    {
      int __gen_e_acsl_size_22;
      int __gen_e_acsl_if_22;
      int __gen_e_acsl_initialized_26;
      __gen_e_acsl_size_22 = 1 * ((2 - 0) + 1);
      if (__gen_e_acsl_size_22 <= 0) __gen_e_acsl_if_22 = 0;
      else __gen_e_acsl_if_22 = __gen_e_acsl_size_22;
      __gen_e_acsl_initialized_26 = __e_acsl_initialized((void *)(dest_4 + 
                                                                  1 * 0),
                                                         (size_t)__gen_e_acsl_if_22);
      __e_acsl_assert(__gen_e_acsl_initialized_26,1,"Assertion","main",
                      "\\initialized(&dest_4[0 .. 2])","tests/libc/str.c",72);
    }
    /*@ assert \initialized(&dest_4[0 .. 2]); */ ;
    {
      int __gen_e_acsl_initialized_27;
      __gen_e_acsl_initialized_27 = __e_acsl_initialized((void *)(& dest_4[3]),
                                                         sizeof(char));
      __e_acsl_assert(! __gen_e_acsl_initialized_27,1,"Assertion","main",
                      "!\\initialized(&dest_4[3])","tests/libc/str.c",73);
    }
    /*@ assert ¬\initialized(&dest_4[3]); */ ;
    __e_acsl_delete_block((void *)(src_4));
    __e_acsl_delete_block((void *)(dest_4));
  }
  __retres = 0;
  __e_acsl_memory_clean();
  return __retres;
}


